BEGIN {
	IGNORECASE = 1;
	netbios_domain = "AD";
	domain = "ad.lan.private";
};
/^<!ENTITY SAMBA____USER_ID_/ {
	split($0, parsed_quotes, "\"");
	generalized_name = parsed_quotes[2];
	if (generalized_name ~ /[-_.[:alnum:]]*\\[-_.[:alnum:]]*/) {
		specialized_name = gensub("XXX_NETBIOSDOMAIN_XXX", netbios_domain, 1, generalized_name);
		cmd = "wbinfo -n '" specialized_name "'";
		cmd | getline resolved_specialized_name;
		close(cmd);
		split(resolved_specialized_name, parsed_specialized_name);
		specialized_sid = parsed_specialized_name[1];
	} else {
		specialized_sid = generalized_name;
	}
	print $1 " " $2 " " "\"*" specialized_sid "\">";
};
/^<!ENTITY SAMBA____SDDL_ACL_/ {
	# TODO: specialize all embedded SIDs inside SDDL expressions
	print "Skipping unsupported SDDL_ACL (" $0 ") specialization" > "/dev/stderr"
};
/^<!ENTITY SAMBA__NETWORK_PATH_/ {
	# Note: only domain-based UNC paths are supported, furthermore generalizing only the domain name (share name left unmodified)
	# TODO: generalize all network/system/share names inside UNCs
	split($0, parsed_quotes, "\"");
	generalized_unc = parsed_quotes[2];
	specialized_unc = gensub("XXX_DNSDOMAIN_XXX", domain, 1, generalized_unc);
	print $1 " " $2 " " "\"" specialized_unc "\">";
};
